diff -uNrp linux-2.6.14.5/include/linux/ltt-time.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt-time.h
--- linux-2.6.14.5/include/linux/ltt-time.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt-time.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,155 @@
+#ifndef _LINUX_LTT_TIME_H
+#define _LINUX_LTT_TIME_H
+/*
+ * linux/include/linux/ltt-time.h
+ *
+ * Copyright (C) 2005 - Mathiey Desnoyers (mathieu.desnoyers@polymtl.ca)
+ * Copyright (C) 2002, 2003 - Tom Zanussi (zanussi@us.ibm.com), IBM Corp
+ * Copyright (C) 2002 - Karim Yaghmour (karim@opersys.com)
+ *
+ * LTT time functions.
+ */
+
+#include <linux/time.h>
+
+#include <asm/ltt.h>
+
+#ifndef LTT_TSC_READY
+
+/**
+ *	calc_time_delta - utility function for time delta calculation
+ *	@now: current time
+ *	@start: start time
+ *
+ *	Returns the time delta produced by subtracting start time from now.
+ */
+static inline u64
+calc_time_delta(struct timeval *now,
+		struct timeval *start)
+{
+	return (now->tv_sec - start->tv_sec) * USEC_PER_SEC
+		+ (now->tv_usec - start->tv_usec);
+}
+
+
+#ifdef LTT_HAS_TSC
+
+/**
+ *	get_time_delta - utility function for getting time delta
+ *	@now: pointer to a timeval struct that may be given current time
+ *	@start: the previous time
+ *
+ *	Returns either the TSC if TSCs are being used, or the time and the
+ *	time difference between the current time and the buffer start time
+ *	if TSCs are not being used.
+ *
+ *	We use arch independant "get_cycles" from timex.h and cast the result
+ *	in a 32 bits variable, keeping the 32 LSB.
+ */
+static inline u64
+get_time_delta(struct timeval *now, struct timeval *start)
+{
+	u64 time_delta;
+
+	time_delta = (u64)get_cycles();
+
+	return time_delta;
+}
+
+/**
+ *	get_timestamp - utility function for getting a time and TSC pair
+ *	@now: current time
+ *	@tsc: the TSC associated with now
+ *
+ *	Sets the value pointed to by now to the current time and the value
+ *	pointed to by tsc to the tsc associated with that time, if the
+ *	platform supports TSC.
+ */
+static inline void
+get_timestamp(struct timeval *now,
+	      u64 *tsc)
+{
+	do_gettimeofday(now);
+	
+	*tsc = (u64)get_cycles();
+}
+
+/**
+ *	get_time_or_tsc - utility function for getting a time or a TSC
+ *	@now: current time
+ *	@tsc: current TSC
+ *
+ *	Sets the value pointed to by now to the current time or the value
+ *	pointed to by tsc to the current tsc, depending on whether we're
+ *	using TSCs or not.
+ */
+static inline void
+get_time_or_tsc(struct timeval *now,
+		u64 *tsc)
+{
+	*tsc = (u64)get_cycles();
+}
+
+#else //!LTT_HAS_TSC
+
+/**
+ *	get_time_delta - utility function for getting time delta
+ *	@now: pointer to a timeval struct that may be given current time
+ *	@start: the previous time
+ *
+ *	Returns either the TSC if TSCs are being used, or the time and the
+ *	time difference between the current time and the buffer start time
+ *	if TSCs are not being used.
+ *
+ *	We use arch independant "get_cycles" from timex.h and cast the result
+ *	in a 32 bits variable, keeping the 32 LSB.
+ *
+ */
+static inline u64
+get_time_delta(struct timeval *now, struct timeval *start)
+{
+	u64 time_delta;
+
+	do_gettimeofday(now);
+	time_delta = calc_time_delta(now, start);
+	return time_delta;
+}
+
+/**
+ *	get_timestamp - utility function for getting a time and TSC pair
+ *	@now: current time
+ *	@tsc: the TSC associated with now
+ *
+ *	Sets the value pointed to by now to the current time and the value
+ *	pointed to by tsc to the tsc associated with that time, if the
+ *	platform supports TSC.
+ */
+static inline void
+get_timestamp(struct timeval *now,
+	      u64 *tsc)
+{
+	do_gettimeofday(now);
+	*tsc = 0;
+}
+
+/**
+ *	get_time_or_tsc - utility function for getting a time or a TSC
+ *	@now: current time
+ *	@tsc: current TSC
+ *
+ *	Sets the value pointed to by now to the current time or the value
+ *	pointed to by tsc to the current tsc, depending on whether we're
+ *	using TSCs or not.
+ */
+static inline void
+get_time_or_tsc(struct timeval *now,
+		u64 *tsc)
+{
+	do_gettimeofday(now);
+}
+
+#endif //LTT_HAS_TSC
+
+#endif //!LTT_TSC_READY
+
+#endif //_LINUX_LTT_TIME_H
diff -uNrp linux-2.6.14.5/include/linux/netlink.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/netlink.h
--- linux-2.6.14.5/include/linux/netlink.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/netlink.h	2006-01-22 13:01:14.000000000 +0100
@@ -21,6 +21,7 @@
 #define NETLINK_DNRTMSG		14	/* DECnet routing messages */
 #define NETLINK_KOBJECT_UEVENT	15	/* Kernel messages to userspace */
 #define NETLINK_GENERIC		16
+#define NETLINK_LTT				31 /* Linux Trace Toolkit : until we have a handle */
 
 #define MAX_LINKS 32		
 
diff -uNrp linux-2.6.14.5/include/linux/preempt.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/preempt.h
--- linux-2.6.14.5/include/linux/preempt.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/preempt.h	2006-01-22 13:01:14.000000000 +0100
@@ -13,41 +13,58 @@
   extern void fastcall add_preempt_count(int val);
   extern void fastcall sub_preempt_count(int val);
 #else
-# define add_preempt_count(val)	do { preempt_count() += (val); } while (0)
-# define sub_preempt_count(val)	do { preempt_count() -= (val); } while (0)
+#define add_preempt_count(val)	do { preempt_count() += (val); } while (0)
+#define sub_preempt_count(val)	do { preempt_count() -= (val); } while (0)
 #endif
 
-#define inc_preempt_count() add_preempt_count(1)
-#define dec_preempt_count() sub_preempt_count(1)
+#define inc_preempt_count()	add_preempt_count(1)
+#define dec_preempt_count()	sub_preempt_count(1)
 
-#define preempt_count()	(current_thread_info()->preempt_count)
+#define preempt_count()		(current_thread_info()->preempt_count)
 
 #ifdef CONFIG_PREEMPT
 
 asmlinkage void preempt_schedule(void);
 
-#define preempt_disable() \
-do { \
-	inc_preempt_count(); \
-	barrier(); \
+#ifdef CONFIG_IPIPE
+
+#include <asm/ipipe.h>
+
+extern struct ipipe_domain *ipipe_percpu_domain[], *ipipe_root_domain;
+
+#define ipipe_preempt_guard()	(ipipe_percpu_domain[ipipe_processor_id()] == ipipe_root_domain)
+#else
+#define ipipe_preempt_guard()	1
+#endif
+
+#define preempt_disable()						\
+do {									\
+	if (ipipe_preempt_guard()) {					\
+		inc_preempt_count();					\
+		barrier();						\
+	}								\
 } while (0)
 
-#define preempt_enable_no_resched() \
-do { \
-	barrier(); \
-	dec_preempt_count(); \
+#define preempt_enable_no_resched()					\
+do {									\
+	if (ipipe_preempt_guard()) {					\
+		barrier();						\
+		dec_preempt_count();					\
+	}								\
 } while (0)
 
-#define preempt_check_resched() \
-do { \
-	if (unlikely(test_thread_flag(TIF_NEED_RESCHED))) \
-		preempt_schedule(); \
+#define preempt_check_resched()						\
+do {									\
+	if (ipipe_preempt_guard()) {					\
+		if (unlikely(test_thread_flag(TIF_NEED_RESCHED)))	\
+			preempt_schedule();				\
+	}								\
 } while (0)
 
-#define preempt_enable() \
-do { \
-	preempt_enable_no_resched(); \
-	preempt_check_resched(); \
+#define preempt_enable()						\
+do {									\
+	preempt_enable_no_resched();					\
+	preempt_check_resched();					\
 } while (0)
 
 #else
diff -uNrp linux-2.6.14.5/include/linux/relayfs_fs.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/relayfs_fs.h
--- linux-2.6.14.5/include/linux/relayfs_fs.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/relayfs_fs.h	2006-01-22 13:01:14.000000000 +0100
@@ -1,6 +1,7 @@
 /*
  * linux/include/linux/relayfs_fs.h
  *
+ * Copyright (C) 2005, Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
  * Copyright (C) 2002, 2003 - Tom Zanussi (zanussi@us.ibm.com), IBM Corp
  * Copyright (C) 1999, 2000, 2001, 2002 - Karim Yaghmour (karim@opersys.com)
  *
@@ -18,6 +19,10 @@
 #include <linux/fs.h>
 #include <linux/poll.h>
 #include <linux/kref.h>
+//#include <linux/percpu.h>
+//#include <linux/preempt.h>
+//#include <linux/err.h>
+//#include <asm/system.h> //for cmpxchg
 
 /*
  * Tracks changes to rchan_buf struct
@@ -34,11 +39,13 @@ struct rchan_buf
 	size_t offset;			/* current offset into sub-buffer */
 	size_t subbufs_produced;	/* count of sub-buffers produced */
 	size_t subbufs_consumed;	/* count of sub-buffers consumed */
+	atomic_t full;		/* buffer is in full state */
 	struct rchan *chan;		/* associated channel */
 	wait_queue_head_t read_wait;	/* reader wait queue */
 	struct work_struct wake_readers; /* reader wake-up work struct */
 	struct dentry *dentry;		/* channel file dentry */
 	struct kref kref;		/* channel buffer refcount */
+	atomic_t open_count;			/* file open count */
 	struct page **page_array;	/* array of current buffer pages */
 	unsigned int page_count;	/* number of current buffer pages */
 	unsigned int finalized;		/* buffer has been finalized */
@@ -46,6 +53,10 @@ struct rchan_buf
 	size_t prev_padding;		/* temporary variable */
 	size_t bytes_consumed;		/* bytes consumed in cur read subbuf */
 	unsigned int cpu;		/* this buf's cpu */
+#ifdef CONFIG_IPIPE
+        struct list_head wake_link;
+        unsigned long wake_posted;
+#endif /* CONFIG_IPIPE */
 } ____cacheline_aligned;
 
 /*
@@ -57,10 +68,16 @@ struct rchan
 	size_t subbuf_size;		/* sub-buffer size */
 	size_t n_subbufs;		/* number of sub-buffers per buffer */
 	size_t alloc_size;		/* total buffer size allocated */
+	int overwrite;			/* overwrite buffer when full? */
 	struct rchan_callbacks *cb;	/* client callbacks */
+	struct file_operations fops; /* file operations */
+	void *client_data; /* client data associated with the client callbacks */
+	void (*free_client_data_cb)(void*); /* Callback function to free the client
+																				 data */
 	struct kref kref;		/* channel refcount */
 	void *private_data;		/* for user-defined data */
 	struct rchan_buf *buf[NR_CPUS]; /* per-cpu channel buffers */
+	struct module *client_module;	/* Client module (for reference count) */
 };
 
 /*
@@ -86,6 +103,7 @@ struct rchan_callbacks
 	 * subbuf_start - called on buffer-switch to a new sub-buffer
 	 * @buf: the channel buffer containing the new sub-buffer
 	 * @subbuf: the start of the new sub-buffer
+	 * @prev_subbuf_idx: the previous sub-buffer's index
 	 * @prev_subbuf: the start of the previous sub-buffer
 	 * @prev_padding: unused space at the end of previous sub-buffer
 	 *
@@ -105,6 +123,18 @@ struct rchan_callbacks
 			     size_t prev_padding);
 
 	/*
+	 * deliver - deliver a guaranteed full sub-buffer to client
+	 * @buf: the channel buffer containing the sub-buffer
+	 * @subbuf_idx: the sub-buffer's index
+	 * @subbuf: the start of the new sub-buffer
+	 *
+	 * Only works if relay_commit is also used
+	 */
+	void (*deliver) (struct rchan_buf *buf,
+			 unsigned subbuf_idx,
+			 void *subbuf);
+
+	/*
 	 * buf_mapped - relayfs buffer mmap notification
 	 * @buf: the channel buffer
 	 * @filp: relayfs file pointer
@@ -123,6 +153,31 @@ struct rchan_callbacks
 	 */
         void (*buf_unmapped)(struct rchan_buf *buf,
 			     struct file *filp);
+
+	/*
+	 * buf_full - relayfs buffer full notification
+	 * @buf: the channel channel buffer
+	 * @subbuf_idx: the current sub-buffer's index
+	 * @subbuf: the start of the current sub-buffer
+	 *
+	 * Called when a relayfs buffer becomes full
+	 */
+	void (*buf_full)(struct rchan_buf *buf,
+			unsigned subbuf_idx,
+			void *subbuf);
+
+	/*
+	 * buf_unfull - relayfs buffer unfull notification
+	 * @buf: the channel channel buffer
+	 * @subbuf_idx: the current sub-buffer's index
+	 * @subbuf: the start of the current sub-buffer
+	 *
+	 * Called when a relayfs buffer passes from full to not full
+	 */
+	void (*buf_unfull)(struct rchan_buf *buf,
+			unsigned subbuf_idx,
+			void *subbuf);
+
 };
 
 /*
@@ -133,7 +188,12 @@ struct rchan *relay_open(const char *bas
 			 struct dentry *parent,
 			 size_t subbuf_size,
 			 size_t n_subbufs,
-			 struct rchan_callbacks *cb);
+			 int overwrite,
+			 struct module *client_module,
+			 struct rchan_callbacks *cb,
+			 struct file_operations *fops,
+			 void *client_data,
+			 void (*free_client_data_cb)(void*));
 extern void relay_close(struct rchan *chan);
 extern void relay_flush(struct rchan *chan);
 extern void relay_subbufs_consumed(struct rchan *chan,
@@ -224,6 +284,7 @@ static inline void *relay_reserve(struct
 		if (!length)
 			return NULL;
 	}
+
 	reserved = buf->data + buf->offset;
 	buf->offset += length;
 
@@ -245,11 +306,5 @@ static inline void subbuf_start_reserve(
 	buf->offset = length;
 }
 
-/*
- * exported relayfs file operations, fs/relayfs/inode.c
- */
-
-extern struct file_operations relayfs_file_operations;
-
 #endif /* _LINUX_RELAYFS_FS_H */
 
diff -uNrp linux-2.6.14.5/include/linux/sched.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/sched.h
--- linux-2.6.14.5/include/linux/sched.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/sched.h	2006-01-22 13:01:14.000000000 +0100
@@ -4,6 +4,7 @@
 #include <asm/param.h>	/* for HZ */
 
 #include <linux/config.h>
+#include <linux/ipipe.h>
 #include <linux/capability.h>
 #include <linux/threads.h>
 #include <linux/kernel.h>
@@ -813,6 +814,9 @@ struct task_struct {
 	int cpuset_mems_generation;
 #endif
 	atomic_t fs_excl;	/* holding fs exclusive resources */
+#ifdef CONFIG_IPIPE
+        void *ptd[IPIPE_ROOT_NPTDKEYS];
+#endif
 };
 
 static inline pid_t process_group(struct task_struct *tsk)
diff -uNrp linux-2.6.14.5/include/linux/seqlock.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/seqlock.h
--- linux-2.6.14.5/include/linux/seqlock.h	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/seqlock.h	2006-01-22 13:01:14.000000000 +0100
@@ -49,6 +49,9 @@ typedef struct {
  */
 static inline void write_seqlock(seqlock_t *sl)
 {
+#ifdef CONFIG_IPIPE
+        local_irq_disable_hw();
+#endif /* CONFIG_IPIPE */
 	spin_lock(&sl->lock);
 	++sl->sequence;
 	smp_wmb();			
@@ -59,16 +62,30 @@ static inline void write_sequnlock(seqlo
 	smp_wmb();
 	sl->sequence++;
 	spin_unlock(&sl->lock);
+#ifdef CONFIG_IPIPE
+        local_irq_enable_hw();
+#endif /* CONFIG_IPIPE */
 }
 
 static inline int write_tryseqlock(seqlock_t *sl)
 {
-	int ret = spin_trylock(&sl->lock);
+	int ret;
+
+#ifdef CONFIG_IPIPE
+        local_irq_disable_hw();
+#endif /* CONFIG_IPIPE */
+
+	ret = spin_trylock(&sl->lock);
 
 	if (ret) {
 		++sl->sequence;
 		smp_wmb();			
 	}
+#ifdef CONFIG_IPIPE
+	else
+	  local_irq_enable_hw();
+#endif /* CONFIG_IPIPE */
+
 	return ret;
 }
 
@@ -145,6 +162,7 @@ static inline void write_seqcount_end(se
 	s->sequence++;
 }
 
+/* IPIPE TODO: to check */ 
 /*
  * Possible sw/hw IRQ protected versions of the interfaces.
  */
diff -uNrp linux-2.6.14.5/init/Kconfig linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/init/Kconfig
--- linux-2.6.14.5/init/Kconfig	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/init/Kconfig	2006-01-22 13:01:14.000000000 +0100
@@ -69,6 +69,7 @@ menu "General setup"
 
 config LOCALVERSION
 	string "Local version - append to kernel release"
+	default "-ipipe"
 	help
 	  Append an extra string to the end of your kernel version.
 	  This will show up when you type uname, for example.
diff -uNrp linux-2.6.14.5/init/main.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/init/main.c
--- linux-2.6.14.5/init/main.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/init/main.c	2006-01-22 13:01:14.000000000 +0100
@@ -48,6 +48,7 @@
 #include <linux/mempolicy.h>
 #include <linux/key.h>
 #include <net/sock.h>
+#include <linux/ltt-core.h>
 
 #include <asm/io.h>
 #include <asm/bugs.h>
@@ -402,6 +403,7 @@ static void noinline rest_init(void)
 	 */
 	schedule();
 
+ 	ipipe_reset_stats();
 	cpu_idle();
 } 
 
@@ -480,6 +482,9 @@ asmlinkage void __init start_kernel(void
 		   __stop___param - __start___param,
 		   &unknown_bootoption);
 	sort_main_extable();
+#ifdef CONFIG_LTT
+	ltt_init();
+#endif //CONFIG_LTT
 	trap_init();
 	rcu_init();
 	init_IRQ();
@@ -487,6 +492,11 @@ asmlinkage void __init start_kernel(void
 	init_timers();
 	softirq_init();
 	time_init();
+	/*
+	 * We need to wait for the interrupt and time subsystems to be
+	 * initialized before enabling the pipeline.
+	 */
+ 	ipipe_init();
 
 	/*
 	 * HACK ALERT! This is early. We're enabling the console before
@@ -611,6 +621,7 @@ static void __init do_basic_setup(void)
 #ifdef CONFIG_SYSCTL
 	sysctl_init();
 #endif
+	ipipe_init_proc();
 
 	/* Networking initialization needs a process context */ 
 	sock_init();
diff -uNrp linux-2.6.14.5/ipc/msg.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ipc/msg.c
--- linux-2.6.14.5/ipc/msg.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ipc/msg.c	2006-01-22 13:01:14.000000000 +0100
@@ -15,6 +15,7 @@
  * (c) 1999 Manfred Spraul <manfreds@colorfullife.com>
  */
 
+#include <linux/ltt/ltt-facility-ipc.h>
 #include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/msg.h>
@@ -232,6 +233,8 @@ asmlinkage long sys_msgget (key_t key, i
 		msg_unlock(msq);
 	}
 	up(&msg_ids.sem);
+	
+	trace_ipc_msg_create(ret, msgflg);
 	return ret;
 }
 
diff -uNrp linux-2.6.14.5/ipc/sem.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ipc/sem.c
--- linux-2.6.14.5/ipc/sem.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ipc/sem.c	2006-01-22 13:01:14.000000000 +0100
@@ -63,6 +63,7 @@
  * (c) 2003 Manfred Spraul <manfred@colorfullife.com>
  */
 
+#include <linux/ltt/ltt-facility-ipc.h>
 #include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/spinlock.h>
@@ -242,6 +243,7 @@ asmlinkage long sys_semget (key_t key, i
 	}
 
 	up(&sem_ids.sem);
+	trace_ipc_sem_create(err, semflg);
 	return err;
 }
 
diff -uNrp linux-2.6.14.5/ipc/shm.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ipc/shm.c
--- linux-2.6.14.5/ipc/shm.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ipc/shm.c	2006-01-22 13:01:14.000000000 +0100
@@ -15,6 +15,7 @@
  *
  */
 
+#include <linux/ltt/ltt-facility-ipc.h>
 #include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/mm.h>
@@ -281,7 +282,7 @@ asmlinkage long sys_shmget (key_t key, s
 		shm_unlock(shp);
 	}
 	up(&shm_ids.sem);
-
+	trace_ipc_shm_create(err, shmflg);
 	return err;
 }
 
diff -uNrp linux-2.6.14.5/kernel/exit.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/exit.c
--- linux-2.6.14.5/kernel/exit.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/exit.c	2006-01-22 13:01:14.000000000 +0100
@@ -4,6 +4,7 @@
  *  Copyright (C) 1991, 1992  Linus Torvalds
  */
 
+#include <linux/ltt/ltt-facility-process.h>
 #include <linux/config.h>
 #include <linux/mm.h>
 #include <linux/slab.h>
@@ -105,6 +106,7 @@ repeat: 
 	spin_unlock(&p->proc_lock);
 	proc_pid_flush(proc_dentry);
 	release_thread(p);
+  trace_process_free(p->pid);
 	put_task_struct(p);
 
 	p = leader;
@@ -846,8 +848,11 @@ fastcall NORET_TYPE void do_exit(long co
 		exit_itimers(tsk->signal);
 		acct_process(code);
 	}
+ 	ipipe_exit_notify(tsk);
 	exit_mm(tsk);
 
+	trace_process_exit(tsk->pid);
+
 	exit_sem(tsk);
 	__exit_files(tsk);
 	__exit_fs(tsk);
@@ -1356,6 +1361,8 @@ static long do_wait(pid_t pid, int optio
 	struct task_struct *tsk;
 	int flag, retval;
 
+	trace_process_wait(current->pid, pid);
+
 	add_wait_queue(&current->signal->wait_chldexit,&wait);
 repeat:
 	/*
diff -uNrp linux-2.6.14.5/kernel/fork.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/fork.c
--- linux-2.6.14.5/kernel/fork.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/kernel/fork.c	2006-01-22 13:01:14.000000000 +0100
@@ -11,6 +11,7 @@
  * management can be a bitch. See 'mm/memory.c': 'copy_page_range()'
  */
 
+#include <linux/ltt/ltt-facility-process.h>
 #include <linux/config.h>
 #include <linux/slab.h>
 #include <linux/init.h>
@@ -1153,6 +1154,14 @@ static task_t *copy_process(unsigned lon
 	total_forks++;
 	write_unlock_irq(&tasklist_lock);
 	retval = 0;
+#ifdef CONFIG_IPIPE
+	{
+	int k;
+
+	for (k = 0; k < IPIPE_ROOT_NPTDKEYS; k++)
+	    p->ptd[k] = NULL;
+	}
+#endif /* CONFIG_IPIPE */
 
 fork_out:
 	if (retval)
@@ -1266,6 +1275,8 @@ long do_fork(unsigned long clone_flags,
 	if (!IS_ERR(p)) {
 		struct completion vfork;
 
+		trace_process_fork(current->pid, p->pid);
+
 		if (clone_flags & CLONE_VFORK) {
 			p->vfork_done = &vfork;
 			init_completion(&vfork);
